export declare type TimerType = 'DECREMENTAL' | 'INCREMENTAL';
export declare type Status = 'RUNNING' | 'PAUSED' | 'STOPPED';
export declare type Config = {
    autostart: boolean;
    endTime: number | null;
    initialTime: number;
    interval: number;
    onTimeOver?: () => void;
    onTimeUpdate?: (time: number) => void;
    step: number;
    timerType: TimerType;
};
export declare type ReturnValue = {
    advanceTime: (timeToAdd: number) => void;
    pause: () => void;
    reset: () => void;
    start: () => void;
    status: Status;
    time: number;
};
export interface State {
    status: Status;
    time: number;
    timerType: TimerType;
}
